function hanoi(n,A,B,C)
if nargin==1, A='A';B='B';C='C';zplot(n);end
if n==1 
    disp(strcat('No',int2str(n),':',A,' -> ',C)) 
    zplot(n,A,C)
else
    hanoi(n-1,A,C,B);
    disp( strcat('No',int2str(n),':',A,' -> ',C))
    zplot(n,A,C)
    hanoi(n-1,B,A,C);
end

%Zhangxiaowei@uestc.edu.cn
function zplot(n,A,C)
if nargin==1
    subplot(1,3,1)
    for i=1:n
        plot([-i/2,i/2],10-[i i],'LineWidth',15);
        hold on;
        text(-0.15,10-i,int2str(i),'Color','w')
    end
    title('ʼA')
    subplot(1,3,2)
    title('мB')
    subplot(1,3,3)
    title('ĿC')
else
    subplot(1,3,findstr('ABC',A))
    hold on
    HUA(n,-1);
    subplot(1,3,findstr('ABC',C))
    hold on
    HUA(n,1)
end

function HUA(n,flag)
if flag==1
    plot([-n/2,n/2],10-[n n],'LineWidth',15);
    text(-0.15,10-n,int2str(n),'Color','w')
else
    plot([-n/2,n/2],10-[n n],'w-','lineWidth',15);
end
hold on;%axis off
box on;
xlim([-6,6]);
ylim([0,10])
pause(1)